//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  c
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1205 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ;

type
  TMyPanel = class(TPanel)
  private
    FStartPoint : TGPPointF;
    FFontName   : string;
    FFontSize   : Single;
    FFontColor  : Cardinal;
    FText       : string;
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+  c';

  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent := Self;
    SetBounds(5, 5, Self.ClientWidth - 10, Self.ClientHeight - 10);
    DoubleBuffered   := True;
    ControlStyle     := MyPanel.ControlStyle + [csOpaque];
    BevelOuter       := bvNone;
    Visible          := True;
    Color            := clWhite;
    ParentBackground := False;
    Anchors          := [akLeft, akTop, akRight, akBottom];
  end;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  RXgN^
//  wiɕ`悷摜p̃rbg}bv
//  ֌W̃vpeBݒ
//  HGŝMicrosoft OfficeɊ܂܂Ă
//-----------------------------------------------------------------------------
constructor TMyPanel.Create(AOwner: TComponent);
begin
  inherited;

  FStartPoint := MakePoint(220.0, 15.0);
  FFontName   := 'HGs';
  FFontSize   := 30;
  FFontColor  := MakeColor(255, 0, 0, 0);
  FText       := 'k̕lӂ' + sLineBreak +
                 'R̂̕lKN' + sLineBreak +
                 'N炯'     + sLineBreak +
                 '        ΐ';
end;

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//
//  StringFormatFlagsDirectionVerticalŏcw
//  StringFormatFlagsDirectionRightToLeftŉs̎̍sƂȂ
//  `JnʒúCEƂȂ̂Œ
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LBitmap       : TBitmap;
  LGPGraphic    : TGPGraphics;
  LGPFontFamily : TGPFontFamily;
  LGPStrFormat  : TGPStringFormat;
  LGPFont       : TGPFont;
  LGPBrush      : TGPSolidBrush;
begin
  inherited;

  //Tv̎|Ɗ֌WȂCwiɉ摜\Ă݂
  LBitmap := TBitmap.Create;
  try
    LBitmap.SetSize(Width, Height);
    LBitmap.LoadFromFile('Hachi.bmp');
    LBitmap.Canvas.StretchDraw(ClientRect, LBitmap);
    Canvas.Draw(0, 0, LBitmap, 80);
  finally
    FreeAndNil(LBitmap);
  end;


  //tHgƃtHgTCYݒ
  LGPFontFamily := TGPFontfamily.Create(FFontName);
  LGPFont       := TGPFont.Create(LGPFontFamily,
                                  FFontSize,
                                  FontStyleRegular,
                                  UnitPixel);

  //TGPStringFormat𐶐āCc̐ݒ
  LGPStrFormat := TGPStringFormat.Create();
  LGPStrFormat.SetFormatFlags(StringFormatFlagsDirectionVertical or
                              StringFormatFlagsDirectionRightToLeft);

  //̃uV(F)ݒ
  LGPBrush := TGPSolidBrush.Create(FFontColor);

  //`̃Rg[CanvasɂTGPGraphics𐶐ĕ`
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  LGPGraphic.DrawString(FText, -1, LGPFont, FStartPoint, LGPStrFormat, LGPBrush);

  //CreateIuWFNg͉
  LGPFontFamily.Free;
  LGPStrFormat.Free;
  LGPFont.Free;
  LGPBrush.Free;
  LGPGraphic.Free;
end;

end.
