//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  `̃ACg s̕\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1205 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ;

type
  TMyPanel = class(TPanel)
  private
    FStringList : TStringList;
  protected
    procedure Paint; override;
    procedure SetParent(AParent: TWinControl); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

  TForm1 = class(TForm)
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  TypInfo;

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  i : Integer;
begin
  Caption := 'GDI+  s̕\';

  //`悷Rg[𐶐
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent := Self;
    SetBounds(5, 110, Self.ClientWidth - 10, Self.ClientHeight - 115);
    DoubleBuffered   := True;
    ControlStyle     := MyPanel.ControlStyle + [csOpaque];
    BevelOuter       := bvNone;
    Visible          := True;
    Color            := clWhite;
    ParentBackground := False;
    Anchors          := [akLeft, akTop, akRight, akBottom];
  end;

  //ACg̑Iڂ쐬
  for i := 0 to 2 do begin
    RadioGroup1.Items.Add(GetEnumName(TypeInfo(TStringAlignment), i));
  end;
  RadioGroup2.Items.Text := RadioGroup1.Items.Text;

  RadioGroup1.ItemIndex := 0;
  RadioGroup2.ItemIndex := 0;

  //s̐ݒ
  CheckBox1.Caption := 'StringFormatFlagsNoWrap';
end;

//=============================================================================
//  RadioGroup1OnClickCxg
//  ICMyPanel1ĕ`
//=============================================================================
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.Invalidate;
end;

//=============================================================================
//  RadioGroup2OnClickCxg
//  ICMyPanel1ĕ`
//=============================================================================
procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.Invalidate;
end;

//=============================================================================
//  ChekcBoox1OnClickCxg
//  삵CMyPanel1ĕ`
//=============================================================================
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.Invalidate;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  RXgN^
//  fBXNǂݏot@C̃eLXgi[TStringList𐶐
//-----------------------------------------------------------------------------
constructor TMyPanel.Create(AOwner: TComponent);
begin
  inherited;
  FStringList := TStringList.Create;
end;

//-----------------------------------------------------------------------------
//  fXgN^
//-----------------------------------------------------------------------------
destructor TMyPanel.Destroy;
begin
  FreeAndNil(FStringList);
  inherited;
end;

//-----------------------------------------------------------------------------
//  SetParent\bh
//  fBXNeLXgt@Cǂݏo
//-----------------------------------------------------------------------------
procedure TMyPanel.SetParent(AParent: TWinControl);
begin
  inherited;
  if not Assigned(FStringList) then exit;

  FStringList.LoadFromFile('AAA.txt');
end;

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//
//  Form1̒lQƂĂ邪C{TMyPanel̃vpeBɂׂ
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LGPGraphic : TGPGraphics;
  LGPFont    : TGPFont;
  LGPStrFmt  : TGPStringFormat;
  LGPBrush   : TGPSolidBrush;
  LGPPen     : TGPPen;
  LGPRect    : TGPRectF;
begin
  inherited;

  //`͈͂̋`̈ݒ
  LGPRect := MakeRect(20.0, 20.0, 250.0, 150.0);

  //TGPFont̃IuWFNg𐶐ݒ
  //̃TCY|CgŎw
  LGPFont := TGPFont.Create('lr oSVbN', 10, FontStyleRegular, UnitPoint);

  //TGPStringFormat𐶐ăACgݒ
  LGPStrFmt := TGPStringFormat.Create;
  //̃ACg
  LGPStrFmt.SetAlignment(TStringAlignment(Form1.RadioGroup1.ItemIndex));
  //̃ACg
  LGPStrFmt.SetLineAlignment(TStringAlignment(Form1.RadioGroup2.ItemIndex));

  //s̐ݒ
  if Form1.CheckBox1.Checked then begin
    LGPStrFmt.SetFormatFlags(StringFormatFlagsNoWrap);
  end;

  //uVŕ̐Fݒ
  LGPBrush := TGPSolidBrush.Create(MakeColor(255, 0, 0, 0));

  //mFp̋``悷yݒ
  LGPPen := TGPPen.Create(aclBlack);

  //`TMyPanelCanvasɎw肵āCTGPGraphics̃IuWFNg𐶐
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);

  //`̈``
  LGPGraphic.DrawRectangle(LGPPen, LGPRect);

  //CanvasɃfBXNǂݏoeLXg`
  LGPGraphic.DrawString(FStringList.Text, -1, LGPFont, LGPRect, LGPStrFmt, LGPBrush);

  //CreateIuWFNg͉
  LGPPen.Free;
  LGPFont.Free;
  LGPStrFmt.Free;
  LGPBrush.Free;
  LGPGraphic.Free;
end;

end.
