//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  VXeɃCXg[Ă邢tHg擾
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1205 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ;

type
  TMyPanel = class(TPanel)
  private
    FpFontFamily : array of TGPFontFamily;
    FFontNumber  : Integer;
    FFontCount   : Integer;
    FFontList    : TStringList;
    procedure SetFontNumber(const Value: Integer);
  protected
    procedure Paint; override;
    procedure SetParent(AParent: TWinControl); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property FontNumber : Integer read FFontNumber write SetFontNumber;
    property FontCount  : Integer read FFontCount;
    property FontList   : TStringList read FFontList;
  end;

  TForm1 = class(TForm)
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+  CXg[ς݂̃tHg';

  ListBox1.Anchors := [akLeft, akTop, akBottom];
  //`悷Rg[𐶐
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent := Self;
    SetBounds(ListBox1.Width + 10, 5, Self.ClientWidth - 105, Self.ClientHeight - 10);
    DoubleBuffered   := True;
    ControlStyle     := MyPanel.ControlStyle + [csOpaque];
    BevelOuter       := bvNone;
    Visible          := True;
    Color            := clWhite;
    ParentBackground := False;
    Anchors          := [akLeft, akTop, akRight, akBottom];
  end;

  ListBox1.Items := MyPanel.FontList;
  ListBox1.ItemIndex := 0;
end;

//=============================================================================
//  ListBox1OnClickCxg
//  ListBox1őItHg\
//=============================================================================
procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.FontNumber := ListBox1.ItemIndex;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  RgN^
//-----------------------------------------------------------------------------
constructor TMyPanel.Create(AOwner: TComponent);
begin
  inherited;

  SetLength(FpFontFamily, 0);
  FFontCount  := 0;
  FFontNumber := -1;
  FFontList   := TStringList.Create;
end;

//-----------------------------------------------------------------------------
//  fRgN^
//-----------------------------------------------------------------------------
destructor TMyPanel.Destroy;
var
  i : Integer;
begin
  //CreateIuWFNg͉
  FreeAndNil(FFontList);
  for i := 0 to Length(FpFontFamily) - 1 do begin
    FpFontFamily[i].Free;
  end;

  inherited;
end;

//-----------------------------------------------------------------------------
//  SetParent\bh
//  eRg[ݒ肳ꂽCtHg̈ꗗ擾CzɊi[
//-----------------------------------------------------------------------------
procedure TMyPanel.SetParent(AParent: TWinControl);
var
  LInstallFontCollection : TGPInstalledFontCollection;
  LCount     : Integer;
  LFontCount : Integer;
  LFontName  : string;
  i          : Integer;
begin
  inherited;
  if not Assigned(AParent) then exit;
  //Ɏ擾ς݂Ȃ擾̃R[hsȂ
  if FFontCount > 0 then exit;


  //VXeɃCXg[ĂtHgRNṼIuWFNg𐶐
  LInstallFontCollection := TGPInstalledFontCollection.Create;
  //CXg[Ă邢tHg擾
  LCount := LInstallFontCollection.GetFamilyCount;

  //i[p̔z̃TCYݒ
  SetLength(FpFontFamily, LCount);

  //z̊evfTGPFontFamilyIuWFNg𐶐
  for i := 0 to LCount - 1 do begin
    FpFontFamily[i] := TGPFontFamily.Create;
  end;
  //zɑSẴtHgi[
  LFontCount := 0;
  LInstallFontCollection.GetFamilies(LCount, FpFontFamily, LFontCount);

  //FontListvpeBɃtHgi[
  for i := 0 to LCount - 1 do begin
    FpFontFamily[i].GetFamilyName(LFontName);
    FFontList.Add(LFontName);
  end;
  //FFontCountvpeB̒l̐ݒƁC\tHgԍݒ
  FFontCount  := LCount;
  FFontNumber := 0;

  //CreateIuWFNg͉
  LInstallFontCollection.Free;
end;

//-----------------------------------------------------------------------------
//  FontNumabervpeB̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TMyPanel.SetFontNumber(const Value: Integer);
var
  LFlag : Boolean;
begin
  if FFontCount = 0 then exit;

  LFlag := (Value >=0) and (Value <= (FFontCount - 1));
  if LFlag and (FFontNumber <> Value) then begin
    FFontNumber := Value;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//  FFontNumberԖڂ̃tHgŁC̃tHg`
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LGPGraphic   : TGPGraphics;
  LGPFont      : TGPFont;
  LGPStrFormat : TGPStringFormat;
  LGPBrush     : TGPSolidBrush;
  LGPDrawRect  : TGPRectF;
  LFontName    : string;
begin
  inherited;
  if FFontCount = 0 then exit;

  //`̋`̈ݒ
  LGPDrawRect := MakeRect(20.0, 20.0, 250.0, 150.0);

  //TGPFont̃IuWFNg𐶐ݒ
  //1́C擾ĂTGPFontFamilyFFontNumberԖڂ̒l
  //tHgX^C͎wȂDTCY|CgŎw
  LGPFont := TGPFont.Create(FpFontFamily[FFontNumber],
                            30,
                            FontStyleRegular,
                            UnitPoint);
  //tHg擾
  FpFontFamily[FFontNumber].GetFamilyName(LFontName);

  //TGPStringFormat𐶐
  //ɉݒ肵ȂŃftHgŎgp
  LGPStrFormat := TGPStringFormat.Create;

  //uVŕ̐Fݒ
  LGPBrush := TGPSolidBrush.Create(MakeColor(255, 0, 0, 0));

  //`TMyPanelCanvasɎw肵āCTGPGraphics̃IuWFNg𐶐
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);

  //CanvasɃtHg`
  LGPGraphic.DrawString(LFontName,
                        - 1,
                        LGPFont,
                        MakePoint(10.0, 10.0),
                        LGPStrFormat,
                        LGPBrush);

  //CreateIuWFNg͉
  LGPFont.Free;
  LGPStrFormat.Free;
  LGPBrush.Free;
  LGPGraphic.Free;
end;

end.
